Imports madrat.Calculate.Parser

Namespace Calculate.Expressions

    Public Class PrefixExpression : Inherits Expression

#Region " Public "

#Region " Constructors "

        <DebuggerHidden()> _
        Public Sub New(ByVal expression As String, Optional ByVal start As Integer = 0)
            MyBase.New(expression, start)
        End Sub

#End Region

#Region " Methods "

        Public Overrides Function TryParse(ByRef ret As ParsedExpression) As Boolean
            Scanner = New PrefixPostfixScanner(Expression, Start)

            Stack = New Stack

            Do Until TypeOf Scanner.Lookahead Is Parser.EndOfStreamToken
                Select Case True
                    Case TypeOf Scanner.Lookahead Is Parser.OperationToken
                        Dim op As Operation = DirectCast(Scanner.Lookahead, Parser.OperationToken).Operation
                        Stack.Push(op)
                    Case TypeOf Scanner.Lookahead Is Parser.FunctionToken
                        Dim fun As [Function] = Functions.ResolveFunction(DirectCast(Scanner.Lookahead, Parser.FunctionToken).Function)
                        Stack.Push(fun)
                    Case TypeOf Scanner.Lookahead Is Parser.NumberToken
                        Stack.Push(DirectCast(Scanner.Lookahead, Parser.NumberToken).Number)
                    Case TypeOf Scanner.Lookahead Is Parser.VariableToken
                        Stack.Push(DirectCast(Scanner.Lookahead, Parser.VariableToken).Variable)
                    Case Else
                        [Error] = New ParseException(Scanner.Position, "An invalid symbol was entered.")
                        ret = Nothing
                        Return False
                End Select

                Scanner.Match(Scanner.Lookahead)
            Loop

            ret = New ParsedExpression(Expression, Stack)
            Return True
        End Function

#End Region

#End Region

    End Class

End Namespace