Namespace Calculate.Expressions

    Public MustInherit Class StackToken

        Public MustOverride Overrides Function ToString() As String

    End Class

    Public Class NumberToken : Inherits StackToken

#Region " Public "

        Public ReadOnly Number As Double

#Region " Constructors "

        Public Sub New(ByVal number As Double)
            Me.Number = number
        End Sub

#End Region

#Region " Methods "

        Public Overrides Function ToString() As String
            Return Number.ToString()
        End Function

#End Region

#End Region

    End Class

    Public Class ListToken : Inherits StackToken

#Region " Public "

        Public ReadOnly Numbers As Values

#Region " Constructors "

        Public Sub New(ByVal number As Values)
            Me.Numbers = number
        End Sub

#End Region

#Region " Methods "

        Public Overrides Function ToString() As String
            Dim ret As New Text.StringBuilder()

            For Each val As Double In Numbers
                ret.AppendLine(val.ToString())
            Next

            Return ret.ToString()
        End Function

#End Region

#End Region

    End Class

    Public Class OperationToken : Inherits StackToken

#Region " Public "

        Public ReadOnly Operation As Operation

#Region " Constructors "

        Public Sub New(ByVal operation As Operation)
            Me.Operation = operation
        End Sub

#End Region

#Region " Methods "

        Public Overrides Function ToString() As String
            Return Operation.ToString()
        End Function

#End Region

#End Region

    End Class

    Public Class FunctionToken : Inherits StackToken

#Region " Public "

        Public ReadOnly [Function] As [Function]

#Region " Constructors "

        Public Sub New(ByVal [function] As [Function])
            Me.Function = [function]
        End Sub

#End Region

#Region " Methods "

        Public Overrides Function ToString() As String
            Return [Function].ToString()
        End Function

#End Region

#End Region

    End Class

    Public Class VariableToken : Inherits StackToken

#Region " Public "

        Public ReadOnly Variable As String

#Region " Constructors "

        Public Sub New(ByVal variable As String)
            Me.Variable = variable
        End Sub

#End Region

#Region " Methods "

        Public Overrides Function ToString() As String
            Return Variable
        End Function

#End Region

#End Region

    End Class

End Namespace