Imports madrat.Calculate.Expressions

Namespace Calculate

    Public Class Functions

#Region " Public "

        Public Shared Function ResolveFunction(ByVal name As String) As [Function]
            Dim ret As [Function] = [Function].KnownFunction(name)
            If ret IsNot Nothing Then Return ret

            If Not Functions.ContainsKey(name) Then Throw New ArgumentException("The function does not exist.")
            Return Functions(name)
        End Function

        Public Shared Function Contains(ByVal name As String) As Boolean
            Return Functions.ContainsKey(name)
        End Function

        Public Shared Sub Add(ByVal name As String, ByVal params As String(), ByVal exp As ParsedExpression)
            Dim fun As New [Function](name, params, AddressOf ExecFunction)
            Functions.Add(name, fun)
            UserFunctions.Add(fun, exp)
        End Sub

        Public Shared Sub Remove(ByVal name As String)
            If Not Functions.ContainsKey(name) Then Return
            UserFunctions.Remove(Functions(name))
            Functions.Remove(name)
        End Sub

        Public Shared Function Iterator() As Dictionary(Of String, [Function]).KeyCollection.Enumerator
            Return Functions.Keys.GetEnumerator()
        End Function

        Public Shared Function ExecFunction(ByVal sender As [Function], ByVal ParamArray values As Values()) As Values
            Dim exp As ParsedExpression = UserFunctions(sender)
            Dim params As New Dictionary(Of String, Values)()

            For i As Integer = 0 To sender.ArgumentNumber - 1
                params.Add(sender.Params(i), values(i))
            Next

            Return exp.Execute(params)
        End Function

#End Region

#Region " Private "

        Private Shared _functions As New Dictionary(Of String, [Function])
        Private Shared _user_functions As New Dictionary(Of [Function], Expressions.ParsedExpression)

        Private Shared ReadOnly Property Functions() As Dictionary(Of String, [Function])
            Get
                Return _functions
            End Get
        End Property

        Private Shared ReadOnly Property UserFunctions() As Dictionary(Of [Function], Expressions.ParsedExpression)
            Get
                Return _user_functions
            End Get
        End Property

#End Region

    End Class

End Namespace