Namespace Calculate.Parser

    Public Class CommandToken : Inherits Token
        Public Command As Command

        Public Sub New(ByVal input As String)
            Me.Command = Calculate.Command.Parse(input)
        End Sub
    End Class

    Public Class NumberToken : Inherits Token
        Public Number As Double

        Public Sub New(ByVal input As Double)
            Me.Number = input
        End Sub

        Public Sub New(ByVal input As String)
            Me.Number = Double.Parse(input, Globalization.NumberFormatInfo.InvariantInfo)
        End Sub
    End Class

    Public Class VariableToken : Inherits Token
        Public Variable As String

        Public Sub New(ByVal input As String)
            Me.Variable = input
        End Sub
    End Class

    Public Class OperationToken : Inherits Token
        Public Operation As Operation

        Public Sub New(ByVal input As String)
            Me.Operation = Calculate.Operation.Parse(input)
        End Sub
    End Class

    Public Class FunctionToken : Inherits Token
        Public [Function] As String

        Public Sub New(ByVal input As String)
            Me.Function = input
        End Sub
    End Class

    Public Class IdentifierToken : Inherits Token
        Public Identifier As String

        Public Sub New(ByVal input As String)
            Me.Identifier = input
        End Sub
    End Class

    Public Class OpenBraceToken : Inherits Token
    End Class

    Public Class CloseBraceToken : Inherits Token
    End Class

    Public Class CommaToken : Inherits Token
    End Class

    Public Class DotDotToken : Inherits Token
    End Class

    Public Class SemicolonToken : Inherits Token
    End Class

    Public Class AssignToken : Inherits Token
    End Class

End Namespace