Namespace Calculate.Parser

    Public Class WordScanner : Inherits Scanner

        Private ReadOnly Tokens As String() = New String() { _
            "Command", "Identifier", "WS", "Error" _
        }

        Public Sub New(ByVal input As String, Optional ByVal start As Integer = 0)
            MyBase.New(input, start)
        End Sub

        Protected Overrides Function GetTokenFromMatch(ByVal match As Text.RegularExpressions.Match) As Token
            For Each find As String In Tokens
                If match.Groups(find).Success Then
                    Select Case find
                        Case "Command"
                            Return New CommandToken(match.Value)
                        Case "Identifier"
                            Return New IdentifierToken(match.Value)
                        Case "WS"
                            Return Nothing
                        Case "Error"
                            Return New ErrorToken(Position)
                    End Select
                End If
            Next

            ' This statement should never be reached.
            Return New ErrorToken(Position)
        End Function

        Protected Overrides Function SearchPattern() As String
            Return _
                "(?<Command>^:[a-z]+)(\b|$)|" & _
                "(?<Identifier>[a-z]+)|" & _
                "(?<WS>(\t| )+)|" & _
                "(?<Error>.+)"
        End Function

    End Class

End Namespace