Imports T = System.Double

Namespace Utility.Functional

    ' HACK: See remark.

    ''' <remarks>
    ''' The functions in this module use the signature which the operators of System.Double would have
    ''' if they were defined within the framework. As it is, they are not so they cannot be referenced
    ''' using delegates. This class fixes this. The functions contained in it are thus mere accesability
    ''' wrappers of the operations on doubles.
    ''' </remarks>
    Public Class Arithmetics

        Public Shared Function op_UnaryNegation(ByVal a As T) As T
            Return -a
        End Function

        Public Shared Function op_Addition(ByVal a As T, ByVal b As T) As T
            Return a + b
        End Function

        Public Shared Function op_Subtraction(ByVal a As T, ByVal b As T) As T
            Return a - b
        End Function

        Public Shared Function op_Multiply(ByVal a As T, ByVal b As T) As T
            Return a * b
        End Function

        Public Shared Function op_Division(ByVal a As T, ByVal b As T) As T
            Return a / b
        End Function

        Public Shared Function op_IntegerDivision(ByVal a As T, ByVal b As T) As T
            Return CLng(a) \ CLng(b)
        End Function

        Public Shared Function op_Modulus(ByVal a As T, ByVal b As T) As T
            Return CLng(a) Mod CLng(b)
        End Function

        Public Shared Function op_Exponent(ByVal a As T, ByVal b As T) As T
            Return a ^ b
        End Function

        Public Shared Function op_LeftShift(ByVal a As T, ByVal b As T) As T
            Return CLng(a) << CInt(b)
        End Function

        Public Shared Function op_RightShift(ByVal a As T, ByVal b As T) As T
            Return CLng(a) >> CInt(b)
        End Function

        Public Shared Function op_OnesComplement(ByVal a As T) As T
            Return Not CLng(a)
        End Function

        Public Shared Function op_BitwiseAnd(ByVal a As T, ByVal b As T) As T
            Return CLng(a) And CLng(b)
        End Function

        Public Shared Function op_BitwiseOr(ByVal a As T, ByVal b As T) As T
            Return CLng(a) Or CLng(b)
        End Function

        Public Shared Function op_ExclusiveOr(ByVal a As T, ByVal b As T) As T
            Return CLng(a) Xor CLng(b)
        End Function

        Public Shared Function Factorial(ByVal a As T) As T
            Dim ret As T = 1

            If a < 0 Then Throw New ArithmeticException("Factorial: argument must be > 0.")
            If Math.IEEERemainder(a, 1.0) <> 0.0 Then _
                Throw New ArithmeticException("Factorial: argument must be integral.")

            Do While a > 0
                ret *= a
                a -= 1
            Loop

            Return ret
        End Function

    End Class

End Namespace